<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2019
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		pct_autogrid
 * @link		http://contao.org
 */

/**
 * Namespaces
 */
namespace PCT\AutoGrid;


/**
 * Imports
 */
use PCT\AutoGrid\Core as AutoGrid;


/**
 * Class file
 * ContentAutoGridCol
 */
class ContentAutoGridCol extends \Contao\ContentElement
{
	/**
	 * Template
	 * @var
	 */
	protected $strTemplate = 'ce_autogrid_col';
	
	
	/**
	 * Display wildcard or backend preview
	 */
	public function generate()
	{
		if (TL_MODE == 'BE')
		{
			$this->Template = new \Contao\BackendTemplate('be_autogrid_wildcard');
			
			if( $this->isGridPreview )
			{
				$this->Template = new \Contao\BackendTemplate('be_autogrid_col');
			}
			
			$this->Template->setData( $this->getModel()->row() );
			
			// add AG to the template
			AutoGrid::addToTemplate($this->Template);
			
			return $this->Template->parse();
		}
		
		if(strlen($this->customTpl) > 0 && $this->customTpl != $this->strTemplate)
		{
			$this->strTemplate = $this->customTpl;
		}
		
		return parent::generate();
	}
	
	/**
	 * Generate the module
	 */
	protected function compile()
	{
		AutoGrid::addToTemplate($this->Template);
		
		// same-height
		$objGrid = $this->Template->AutoGrid->GridStart;
		
		// has attributes
		if( ($this->Template->AutoGrid->hasStyles || $objGrid->autogrid_sameheight || $this->autogrid_padding_css) && $this->type == 'autogridColStart')
		{
			$this->Template->AutoGrid->hasAttributes = true;
			$GLOBALS['PCT_AUTOGRID']['HAS_ATTRIBUTES'] = true;
		}
		// background has been started and should now be closed
		if($this->type == 'autogridColStop' && $GLOBALS['PCT_AUTOGRID']['HAS_ATTRIBUTES'] === true)
		{
			$this->Template->AutoGrid->hasAttributes = true;
			unset($GLOBALS['PCT_AUTOGRID']['HAS_ATTRIBUTES']);
		}

		if($objGrid->autogrid_sameheight && $this->type == 'autogridColStart')
		{
			$this->Template->AutoGrid->hasAttributes = true;
			$this->Template->AutoGrid->shstart = true;
			$GLOBALS['PCT_AUTOGRID']['SAME-HEIGHT_START'] = true;
		}

		// same-height has been started and should now be closed
		if($this->type == 'autogridColStop' && $GLOBALS['PCT_AUTOGRID']['SAME-HEIGHT_START'] === true)
		{
			$this->Template->AutoGrid->hasAttributes = true;
			$this->Template->AutoGrid->shstop = true;
			unset($GLOBALS['PCT_AUTOGRID']['SAME-HEIGHT_START']);
		}
	}
}