<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2014, Premium Contao Webworks, Premium Contao Themes
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		pct_customelements
 * @link		http://contao.org
 */

/**
 * Namespace
 */
namespace PCT\CustomElements\Models;

/**
 * Class file
 * PluginModel
 */
class PluginModel extends \Contao\Model 
{
	/**
	 * Table
	 * @var string
	 */
	protected static $strTable = 'tl_pct_customelement_plugin';
	
	
	/**
	 * Create a new Instance 
	 */
	public function __construct($objResult=null,$blnRegister=true)
	{
		if($objResult !== null && $blnRegister === false)
		{
			static::setRow($objResult->row());
		}
		
		if($blnRegister)
		{
			parent::__construct($objResult);
		}
	}
	
	
	/**
	 * Find a plugin model by the plugin alias
	 * @param string	Registration key of the plugin 
	 * @param array   	An optional options array
	 *
	 * @return \PCT\CustomElements\Models\PluginModel or null
	 */
	public static function findByAlias($strKey, array $arrOptions=array())
	{
		$t = static::$strTable;
		
		if(!\Contao\Database::getInstance()->tableExists($t))
		{
			return null;
		}
		
		return static::findOneBy("plugin", array($strKey), $arrOptions);
	}

	
	/**
	 * Find all published / active plugins
	 * @param array   	An optional options array
	 *
	 * @return \Model\Collection or null
	 */
	public static function findAllPublished($arrOptions=array())
	{
		$t = static::$strTable;
		
		if(!\Contao\Database::getInstance()->tableExists($t))
		{
			return null;
		}
		
		return static::findBy(array("published"), array(1), $arrOptions);
	}
}