<?php

/**
 * Contao Open Source CMS
 *
 * Copyright (c) 2005-2013 Leo Feyer
 *
 * @package Revolutionslider
 * @link    https://contao.org
 * @license http://www.gnu.org/licenses/lgpl-3.0.html LGPL
 */


/**
 * Register the namespaces
 */
ClassLoader::addNamespaces(array
(
	'RevolutionSlider',
));


/**
 * Register the classes
 */
ClassLoader::addClasses(array
(
	// RevolutionSlider
	'RevolutionSlider\Backend\TableContent'                  => 'system/modules/pct_revolutionslider/RevolutionSlider/Backend/TableContent.php',
	'RevolutionSlider\Backend\TableRevolutionSlider'         => 'system/modules/pct_revolutionslider/RevolutionSlider/Backend/TableRevolutionSlider.php',
	'RevolutionSlider\Backend\TableRevolutionSliderSlides'   => 'system/modules/pct_revolutionslider/RevolutionSlider/Backend/TableRevolutionSliderSlides.php',
	'RevolutionSlider\Backend\TableUserGroup'                => 'system/modules/pct_revolutionslider/RevolutionSlider/Backend/TableUserGroup.php',
	'RevolutionSlider\Core\Factory'                          => 'system/modules/pct_revolutionslider/RevolutionSlider/Core/Factory.php',
	'RevolutionSlider\Core\Hooks'                            => 'system/modules/pct_revolutionslider/RevolutionSlider/Core/Hooks.php',
	'RevolutionSlider\Core\InsertTags'                       => 'system/modules/pct_revolutionslider/RevolutionSlider/Core/InsertTags.php',
	'RevolutionSlider\Core\RevolutionSlider'                 => 'system/modules/pct_revolutionslider/RevolutionSlider/Core/RevolutionSlider.php',
	'RevolutionSlider\Core\Slide'                            => 'system/modules/pct_revolutionslider/RevolutionSlider/Core/Slide.php',
	'RevolutionSlider\Core\SlideFactory'                     => 'system/modules/pct_revolutionslider/RevolutionSlider/Core/SlideFactory.php',
	'RevolutionSlider\Frontend\ContentRevolutionSlider'      => 'system/modules/pct_revolutionslider/RevolutionSlider/Frontend/ContentRevolutionSlider.php',
	'RevolutionSlider\Frontend\ContentRevolutionSliderVideo' => 'system/modules/pct_revolutionslider/RevolutionSlider/Frontend/ContentRevolutionSliderVideo.php',
	'RevolutionSlider\Frontend\ContentRevolutionSliderText'  => 'system/modules/pct_revolutionslider/RevolutionSlider/Frontend/ContentRevolutionSliderText.php',
	'RevolutionSlider\Frontend\ContentRevolutionSliderImage' => 'system/modules/pct_revolutionslider/RevolutionSlider/Frontend/ContentRevolutionSliderImage.php',
	'RevolutionSlider\Frontend\ContentRevolutionSliderHyperlink' => 'system/modules/pct_revolutionslider/RevolutionSlider/Frontend/ContentRevolutionSliderHyperlink.php',
	'RevolutionSlider\Models\Slider'						 => 'system/modules/pct_revolutionslider/RevolutionSlider/Models/Slider.php',
	'RevolutionSlider\Models\Slides'						 => 'system/modules/pct_revolutionslider/RevolutionSlider/Models/Slides.php',
));


/**
 * Register the templates
 */
TemplateLoader::addFiles(array
(
	'ce_revolutionslider'       => 'system/modules/pct_revolutionslider/templates',
	'ce_revolutionslider_video' => 'system/modules/pct_revolutionslider/templates',
	'ce_revolutionslider_text'	=> 'system/modules/pct_revolutionslider/templates',
	'ce_revolutionslider_image'	=> 'system/modules/pct_revolutionslider/templates',
	'ce_revolutionslider_hyperlink'	=> 'system/modules/pct_revolutionslider/templates',
	'js_revoslider_default'     => 'system/modules/pct_revolutionslider/templates',
	'revoslider_default'        => 'system/modules/pct_revolutionslider/templates',
));
