<?php

/**
 * Contao Open Source CMS
 *
 * Copyright (C) 2005-2013 Leo Feyer
 *
 * @copyright	Tim Gatzky 2019
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		pct_theme_settings
 * @link		http://contao.org
 */


/**
 * Register the namespaces
 */
\Contao\ClassLoader::addNamespaces(array
(
	'PCT',
));


/**
 * Register the classes
 */
\Contao\ClassLoader::addClasses(array
(
	'PCT\ThemeSettings\Core' 					=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/Core.php',
	'PCT\ThemeSettings\ContaoCallbacks' 		=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/ContaoCallbacks.php',
	'PCT\ThemeSettings\Backend\TableContent' 	=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/Backend/TableContent.php',
	'PCT\ThemeSettings\Backend\TableArticle' 	=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/Backend/TableArticle.php',
	'PCT\ThemeSettings\Backend\TableModule' 	=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/Backend/TableModule.php',
#	'PCT\ThemeSettings\Backend\TableFormField' 		=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/Backend/TableFormField.php',
	'PCT\ThemeSettings\Backend\TablePage' 		=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/Backend/TablePage.php',
	'PCT\ThemeSettings\PageImage\Module' 		=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/PageImage/Module.php',
	'PCT\ThemeSettings\PageArticle\Module' 		=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/PageArticle/Module.php',
	'PCT\ThemeSettings\Privacy\ModuleOptIn' 	=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/Privacy/ModuleOptIn.php',
	'PCT\ThemeSettings\Privacy\ModuleOptOut' 	=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/Privacy/ModuleOptOut.php',
	'PCT\ThemeSettings\Portfolio\ModuleList' 	=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/Portfolio/ModuleList.php',
	'PCT\ThemeSettings\Portfolio\ModuleReader' 	=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/Portfolio/ModuleReader.php',
	'PCT\ThemeSettings\Portfolio\ModuleFilter' 	=> 'system/modules/pct_theme_settings/PCT/ThemeSettings/Portfolio/ModuleFilter.php',
));


/**
 * Register the templates
 */
\Contao\TemplateLoader::addFiles(array
(
	'mod_article' 				=> 'system/modules/pct_theme_settings/templates',
	'ce_headline_seo'			=> 'system/modules/pct_theme_settings/templates',
	'ce_text_seo'				=> 'system/modules/pct_theme_settings/templates',
	'block_searchable_seo'		=> 'system/modules/pct_theme_settings/templates',
	//pageimage,article
	'mod_pageimage' 			=> 'system/modules/pct_theme_settings/templates/page',
	'mod_pagearticle' 			=> 'system/modules/pct_theme_settings/templates/page',
	// privacy
	'mod_privacy_default' 		=> 'system/modules/pct_theme_settings/templates/privacy',
	'mod_privacy_medium' 		=> 'system/modules/pct_theme_settings/templates/privacy',
	'mod_privacy_slim' 			=> 'system/modules/pct_theme_settings/templates/privacy',
	'mod_privacy_no_optin_cookiebar'	=> 'system/modules/pct_theme_settings/templates/privacy',
	'mod_auto_optout' 			=> 'system/modules/pct_theme_settings/templates/privacy',
	// portfolio
	'mod_portfoliolist' 		=> 'system/modules/pct_theme_settings/templates/portfolio',
	'mod_portfolioreader' 		=> 'system/modules/pct_theme_settings/templates/portfolio',
	'mod_portfoliofilter' 		=> 'system/modules/pct_theme_settings/templates/portfolio',
	'portfoliofilter_php' 		=> 'system/modules/pct_theme_settings/templates/portfolio',
	'portfoliofilter_isotope' 	=> 'system/modules/pct_theme_settings/templates/portfolio',
	'portfolio_latest' 			=> 'system/modules/pct_theme_settings/templates/portfolio',
));
